#include <stdlib.h>
#include <stdio.h>
void MvdGetSerialChanges( int hmbit[16], int tgvbit[8][190], 
                          int amubit[8][33] )
{
   /* scan a command line to look serial string changes              */

   /* input hmbit, tgvbit, amubit                                    */

   /* Author = JPSullivan 23-May-2000 (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* Modified: 2-Aug-2000 JPS added MvdSetAmuBits command           */
   /*           3-Aug-2000 JPS added MvdSetTgvBits command           */
   /*          21-Jun-2000 JPS added status and help commands        */

   /* **********************************************************     */

   void MvdSetHmBits      ( char cline[80], int hmbit[16], int amubit[8][33] );
   void MvdSetAmuBits     ( char cline[80], int amubit[8][33] );
   void MvdSetTgvBits     ( char cline[80], int tgvbit[8][190] );
   void MvdShowStatus     ( int hmbit[16], int tgvbit[8][190],
                            int amubit[8][33] );


   int i;
   char cline[80];
   char arg1[80];

   /* ********************************************************** */

   while( fgets( cline, 80, stdin ) != NULL )
   {
      sscanf (cline, "%s", arg1 );

      for ( i=0; i<strlen(arg1); i++ )
         arg1[i] = tolower(arg1[i]);

      /* Either ex[it] or qu[it] exits          */
      if ( arg1[0] == 'e' && arg1[1] == 'x' )
          return;
      if ( arg1[0] == 'q' && arg1[1] == 'u' )
          return;

      if ( arg1[0] == 'h' && arg1[1] == 'm' ) 
      {
          /* hm = heap manager commands             */
          MvdSetHmBits( cline, hmbit, amubit );
      }
      else if ( arg1[0] == 'a' && arg1[1] == 'm' ) 
      {
          /* am = amu/adc commands                  */
          MvdSetAmuBits( cline, amubit );
      }
      else if ( arg1[0] == 't' && arg1[1] == 'g' ) 
      {
          /* tg = TGV preamp/disc commands          */
          MvdSetTgvBits( cline, tgvbit );
      }
      else if ( arg1[0] == 's' && arg1[1] == 't' )
      {
          /* st = status report                     */
          MvdShowStatus ( hmbit, tgvbit, amubit ); 
      }
      else if ( arg1[0] == 'h' && arg1[1] == 'e' )
      {
          /* he = help                              */
          printf ( " Commands are of the form\nhm test 0\namu iref 5.3\n");
          printf ( "tgv predis 8 31 0\nstatus\n");
          printf ( " There is no helpful help menu, but look at\n");
          printf ( " http://p25ext.lanl.gov/phenix/mvd/elect/serial/ \n");
      }
      else
          fprintf ( stderr, 
                    "MvdGetSerialChanges: unknown command=%s\n",
                    arg1);
   }

   return;
}
