#include <stdlib.h>
#include <stdio.h>
void MvdSetTgvCsdis( char cline[80], int tgvchan, int tgvbit[8][190] )
{
   /* "Current sum" (discriminator) disable for one or more TGV      */
   /* channels                                                       */

   /* tgvchan = 0 means all 8 chips on the MCM,                      */
   /*           1-8 refer to individual chips.                       */
   /* nchan (internal variable) = 0 means all channels on the chip   */
   /*                           = 1-8 refers to single channels      */

   /* input cline   = the whole command line                         */
   /*       tgvchan = the tgv channel this command applies to.       */
   /*                 numbering is 1-8 (not 0-7) because 0 ususally  */
   /*                 means set this bit for all channels.           */
   /*                 one Calen at a time should be on.              */
   /*       tgvbit  = The array of TGV serial string bits (an integer*/
   /*                 array containg 1's and 0's). First index is    */
   /*                 chip number, 2nd is the serial bit number.     */                  

   /* Author = JPSullivan 4-Aug-2000  (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* **********************************************************     */

   char arg1[80];
   char arg2[80];
   char arg3[80];
   int i;                /* loop index */
   int j;                /* loop index */
   int loop1,loop2;      /* lower,upper loop limits */
   int onoff;
   int nchan; 
   int nchan2;

   /* ********************************************************** */

   sscanf ( cline, "%s%s%s%d%d", arg1, arg2, arg3, &nchan, &onoff );

   if ( nchan > 32 ) nchan = 32;
   if ( nchan < 0  ) nchan = 0;

   if ( onoff < 0  ) onoff = 0;    /* 0 (normal) means channel is on */
   if ( onoff > 1  ) onoff = 1;    /* 1 means disable channel */

   /* here we change the input channel variable to a new variable which */
   /* is used as an array index (0-31 rather than 1-32)                 */

   nchan2   = nchan - 1;

   /* disable the requested channel(s) */

   if ( tgvchan == 0 ) 
   {
     loop1 = 0;
     loop2 = 7;
   }
   else
   {
     loop1 = tgvchan - 1;
     loop2 = loop1;
   }

   /* set the bits corresponding to the channel number */

   for ( i=loop1; i<=loop2; i++ )
   {
      for ( j=0; j<=31; j++ )
      {
         if ( j==nchan2 | nchan==0 )
         {
           tgvbit[i][j] = onoff;
         }
      }
   }

   return;
}
