#include <stdlib.h>
#include <stdio.h>
void MvdSetTgvDtwk( char cline[80], int tgvchan, int tgvbit[8][190] )
{
   /* Discriminator "tweak" bits. I am not certain how these work.   */
   /* Bits 63-32 are "bit a" for channels 0-31.                      */
   /* Bits 95-64 are "bit b" for channels 0-31.                      */
   /* The code assumes that "bit a" is the low order bit and "bit b" */
   /* is the higher order bit in a two bit word (i.e. counts 0 to 3).*/
   /* The input command takes an arguement from 0 to 3 and sets these*/
   /* bits with the assumptions above. We have never tested these    */
   /* bits seriously, so I do not even know if 0 or 3 corresponds to */
   /* high or low.                                                   */
   /* These bits are intended to provide a fine channel to channel   */
   /* adjust for the coarse threshold set for all 32 channels on a   */
   /* TGV chip via the Vthr DAC.                                     */

   /* input cline   = the whole command line                         */
   /*       tgvchan = the tgv channel this command applies to.       */
   /*                 numbering is 1-8 (not 0-7) because 0 ususally  */
   /*                 means set this bit for all channels.           */
   /*                 one Calen at a time should be on.              */
   /*       tgvbit  = The array of TGV serial string bits (an integer*/
   /*                 array containg 1's and 0's). First index is    */
   /*                 chip number, 2nd is the serial bit number.     */                  

   /* nchan (internal variable) = 0 means all channels on the chip   */
   /*                           = 1-8 refers to single channels      */

   /* Author = JPSullivan 4-Aug-2000  (based on labwindows code      */
   /*          originally written by BSchlei and SSRyu)              */

   /* **********************************************************     */

   char arg1[80];
   char arg2[80];
   char arg3[80];
   int i;                /* loop index */
   int j;                /* loop index */
   int loop1,loop2;      /* lower,upper loop limits */
   int ithr;
   int nchan; 
   int nchan2;
   int bitvals[2] = {0x1, 0x2};

   /* ********************************************************** */

   sscanf ( cline, "%s%s%s%d%d", arg1, arg2, arg3, &nchan, &ithr );

   if ( nchan > 32 ) nchan = 32;
   if ( nchan < 0  ) nchan = 0;

   if ( ithr < 0  ) ithr = 0;
   if ( ithr > 3  ) ithr = 3;

   /* here we change the input channel variable to a new variable which */
   /* is used as an array index (0-31 rather than 1-32)                 */

   nchan2   = nchan - 1;

   /* set the bits for the requested channels */

   if ( tgvchan == 0 ) 
   {
     loop1 = 0;
     loop2 = 7;
   }
   else
   {
     loop1 = tgvchan - 1;
     loop2 = loop1;
   }

   /* set the bits corresponding to the channel number */

   for ( i=loop1; i<=loop2; i++ )
   {
      for ( j=0; j<=31; j++ )
      {
         if ( j==nchan2 | nchan==0 )
         {
           if ( (ithr & bitvals[0] ) !=0 )
           {
             tgvbit[i][63-j] = 1;
           }
           else
           {
             tgvbit[i][63-j] = 0;
           }
           if ( (ithr & bitvals[1] ) !=0 )
           {
             tgvbit[i][95-j] = 1;
           }
           else
           {
             tgvbit[i][95-j] = 0;
           }
         }
      }
   }

   return;
}
