#include <stdlib.h>
#include <stdio.h>
void MvdWriteMcmResponse( FILE *fprsp, int SerialBitsOut[1800] )
{
   /* Write Serial string data to a file in the format used      */
   /* to read back the response from the serial string           */

   /* input = fprsp = pointer in (already open) output file      */
   /* input = SerialBitsOut                                      */

   /* Author = JPSullivan 27-Jun-2001 (based on MvdWriteMcmOut.c */

   /* ********************************************************** */

    int bcnt,val1,val2;
    int bitnum;
    int nWordOut;
    int nLineOut;
    int dataout;
    int bitvals[8] = {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

    int SerialReadCommand = 0x34;
    int NBytesOut;

   /* ********************************************************** */

    nWordOut = 0;
    nLineOut = 0;

    NBytesOut = (1800/8) + 8;    /* 1800 data bits, packed into bytes */
                                 /* plus 8 bits in the header word    */

    /* write the header */
    /* The first line is the message you see if everything is OK. */
    /* The second line is the message you see if there is a readback error */
    /* The first character on the next line will be the arcnet node, an "x" */
    /* means accept any value. The next item is the code for the serial read */
    /* function in acrnet. The next item is always zero (I don't know what it is). */
    /* The last item on the third line is the group ID, which is always */
    /* 20 hex for the MVD. The first two items on the 4th line are */
    /* always zero. I do not know what they are. The 3rd item is the upper */
    /* part of the 16 bit word giving the number of bytes of data. The 4th */
    /* word is the lower 8 bits of the same word. */

    fprintf ( fprsp, "MVD: serial run string loaded\n"); 
    fprintf ( fprsp, "*** ERROR loading serial run string ***\n");
    fprintf ( fprsp, "x %x %x %x\n", SerialReadCommand, 0x0, 0x20 );
    fprintf ( fprsp, "%x %x %x %x\n",0x0,0x0,NBytesOut>>8,NBytesOut&0xFF);

    /* now write the data to the file */

    for (bcnt = 0; bcnt < 1800; bcnt++) {
        /* fprintf ( fprsp, "%i %i\n", bcnt, SerialBitsOut[bcnt]); */
        bitnum = bcnt%8;
        if ( bitnum==0 ) 
        {
          dataout = 0;
        }
        if ( SerialBitsOut[bcnt] != 0 ) 
        {
           dataout = dataout | bitvals[bitnum];
        }
        if ( bitnum == 7 )
        {
          fprintf ( fprsp, "%3x",dataout);
          nWordOut++;
        }
        if ( (nWordOut%16 == 0) && (bitnum == 7) )
        {
          fprintf ( fprsp, "\n");
          nLineOut++;
        }
    }

    /* fprintf ( stdout, "%d words of serial data to output, %d lines\n", */
    /*          nWordOut,nLineOut);                                       */
    /* fprintf ( stdout,                                                  */
    /*          "total bytes of data in file = %x (hex)\n", NBytesOut );  */

    fclose(fprsp);                         /* close output file */
    
    return;
}
