#include <stdlib.h>
#include <stdio.h>
void MvdWriteMcmSerial2( FILE *fpout, int SerialBitsOut[1800] )
{
   /* Write Serial string data to a file in the format used      */
   /* by the arcnet program                                      */

   /* input = fpout = pointer in (already open) output file      */
   /* input = SerialBitsOut                                      */

   /* Author = JPSullivan 22-May-2000 (based on labwindows code  */
   /*          originally written by BSchlei and SSRyu)          */

   /* ********************************************************** */

    int bcnt,val1,val2;
    int bitnum;
    int nWordOut;
    int nLineOut;
    int dataout;
    int bitvals[8] = {0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

    int McmSerialCommand = 0x35;
    int NBytesOut;

   /* ********************************************************** */

    nWordOut = 0;
    nLineOut = 0;

    NBytesOut = (1800/8) + 8;    /* 1800 data bits, packed into bytes */
                                 /* plus 8 bits in the header word    */

    /* write the header */

    fprintf ( fpout, "%x %x %x %x\n",0x0, McmSerialCommand, 0x0, 0x20 );
    fprintf ( fpout, "%x %x %x %x\n",0x0,0x0,NBytesOut>>8,NBytesOut&0xFF);

    /* now write the data to the file */

    for (bcnt = 0; bcnt < 1800; bcnt++) {
        /* fprintf ( fpout, "%i %i\n", bcnt, SerialBitsOut[bcnt]); */
        bitnum = bcnt%8;
        if ( bitnum==0 ) 
        {
          dataout = 0;
        }
        if ( SerialBitsOut[bcnt] != 0 ) 
        {
           dataout = dataout | bitvals[bitnum];
        }
        if ( bitnum == 7 )
        {
          fprintf ( fpout, "%3x",dataout);
          nWordOut++;
        }
        if ( (nWordOut%16 == 0) && (bitnum == 7) )
        {
          fprintf ( fpout, "\n");
          nLineOut++;
        }
    }

    /* fprintf ( stdout, "%d words of serial data to output, %d lines\n", */
    /*          nWordOut,nLineOut);                                       */
    /* fprintf ( stdout,                                                  */
    /*          "total bytes of data in file = %x (hex)\n", NBytesOut );  */

    fclose(fpout);                         /* close output file */
    
    return;
}
